import unittest
from test import test_support

class MyTestCase1(unittest.TestCase):

    # Only use setUp() and tearDown() if necessary

    def setUp(self):
        print "setup"

    def tearDown(self):
        print "teardown"

    def test_feature_one(self):
        # Test feature one.
        pass

    def test_feature_two(self):
        # Test feature two.
        pass

    def test_f_one(self):
        pass


class MyTestCase2(unittest.TestCase):

    # Only use setUp() and tearDown() if necessary

    def setUp(self):
        print "setup number two"

    def tearDown(self):
        print "teardown"
        
    def test_f_one(self):
        # Test feature one.
        self.failUnless(1==2)

    def test_f_two(self):
        # Test feature two.
        self.failUnless(1==1)

    def test_f_three(self):
        # Test feature two.
        foobarbaz

class MyTestSuite(unittest.TestSuite):
    def __init__(self):
        unittest.TestSuite.__init__(self,
                                    map(MyTestCase2,
                                        ("test_f_one",
                                         "test_f_two",
                                         "test_f_three")) +
                                    map(MyTestCase1,
                                        ("test_feature_one",
                                         "test_feature_two",
                                         "test_f_one")))

class MyTestSuiteOne(unittest.TestSuite):
    def __init__(self):
        unittest.TestSuite.__init__(self,
                                    map(MyTestCase1,
                                        ("test_feature_one",
                                         "test_feature_two",
                                         "test_f_one")))

class MyTestSuiteTwo(unittest.TestSuite):
    def __init__(self):
        unittest.TestSuite.__init__(self,
                                    map(MyTestCase2,
                                        ("test_f_one",
                                         "test_f_two",
                                         "test_f_three")))

class MyTestAllSuites(unittest.TestSuite):
    def __init__(self):
        unittest.TestSuite.__init__(self,
                                    (MyTestSuiteOne(),
                                     MyTestSuiteTwo()))


def suite():
    suite = unittest.TestSuite()
    suite.addTest(MyTestCase1('test_feature_one'))
    suite.addTest(MyTestCase1('test_feature_two'))
    suite.addTest(MyTestCase2('test_f_three'))
    return suite

def test_main():
    unittest.main(defaultTest='MyTestAllSuites')

if __name__ == '__main__':
    test_main()
